/*
Impact Physics
by Spearminty
*/
#define _USE_MATH_DEFINES
#include <math.h>
#include "script.h"
#include "config.h"
#include <string>
#include <ctime>
#include <list>
#include <set>
#include <algorithm> 
using namespace std;
#pragma warning(disable : 4244 4305) // double <-> float conversions

static Vector3 RotationToDirection(Vector3 Rotation)
{
	Vector3 v;
	float z = Rotation.z;
	float num = z * 0.0174532924f;
	float x = Rotation.x;
	float num2 = x * 0.0174532924f;
	float num3 = abs((float)cos((double)num2));
	v.x = (float)((double)((float)(-(float)sin((double)num))) * (double)num3);
	v.y = (float)((double)((float)cos((double)num)) * (double)num3);
	v.z = (float)sin((double)num2);
	return v;
}
list<WeaponStats> statList;
static bool AreVectorsEqual(Vector3 vectorA, Vector3 vectorB)
{
	if (vectorA.x == vectorB.x && vectorA.y == vectorB.y && vectorA.z == vectorB.z)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void draw_rect(float A_0, float A_1, float A_2, float A_3, int A_4, int A_5, int A_6, int A_7)
{
	GRAPHICS::DRAW_RECT((A_0 + (A_2 * 0.5f)), (A_1 + (A_3 * 0.5f)), A_2, A_3, A_4, A_5, A_6, A_7);
}
void draw_menu_line(std::string caption, float lineWidth, float lineHeight, float lineTop, float lineLeft, float textLeft, bool active, bool title, bool rescaleText = true)
{
	// default values
	int text_col[4] = { 255, 255, 255, 255 },
		rect_col[4] = { 70, 95, 95, 255 };
	float text_scale = 0.35;
	int font = 0;

	// correcting values for active line
	if (active)
	{
		text_col[0] = 0;
		text_col[1] = 0;
		text_col[2] = 0;

		rect_col[0] = 218;
		rect_col[1] = 242;
		rect_col[2] = 216;

		if (rescaleText) text_scale = 0.40;
	}

	if (title)
	{
		rect_col[0] = 0;
		rect_col[1] = 0;
		rect_col[2] = 0;

		if (rescaleText) text_scale = 0.50;
		font = 1;
	}

	int screen_w, screen_h;
	GRAPHICS::GET_SCREEN_RESOLUTION(&screen_w, &screen_h);

	textLeft += lineLeft;

	float lineWidthScaled = lineWidth / (float)screen_w; // line width
	float lineTopScaled = lineTop / (float)screen_h; // line top offset
	float textLeftScaled = textLeft / (float)screen_w; // text left offset
	float lineHeightScaled = lineHeight / (float)screen_h; // line height

	float lineLeftScaled = lineLeft / (float)screen_w;

	// this is how it's done in original scripts

	// text upper part
	UI::SET_TEXT_FONT(font);
	UI::SET_TEXT_SCALE(0.0, text_scale);
	UI::SET_TEXT_COLOUR(text_col[0], text_col[1], text_col[2], text_col[3]);
	UI::SET_TEXT_CENTRE(0);
	UI::SET_TEXT_DROPSHADOW(0, 0, 0, 0, 0);
	UI::SET_TEXT_EDGE(0, 0, 0, 0, 0);
	UI::_SET_TEXT_ENTRY("STRING");
	UI::_ADD_TEXT_COMPONENT_STRING((LPSTR)caption.c_str());
	UI::_DRAW_TEXT(textLeftScaled, (((lineTopScaled + 0.00278f) + lineHeightScaled) - 0.005f));

}
std::string caption = "SHOOT";
std::string caption2 = "grabbed";
std::string caption3 = "force";
std::string caption4 = "my rot";
std::string caption5 = "my rot";
//std::string caption6 = "x";
//std::string caption7 = "x";

Vector3 add(Vector3* vectorA, Vector3* vectorB)
{
	Vector3 result;
	result.x = vectorA->x;
	result.y = vectorA->y;
	result.z = vectorA->z;

	result.x += vectorB->x;
	result.y += vectorB->y;
	result.z += vectorB->z;

	return result;
}

Vector3 multiply(Vector3* vector, float x)
{
	Vector3 result;
	result.x = vector->x;
	result.y = vector->y;
	result.z = vector->z;

	result.x *= x;
	result.y *= x;
	result.z *= x;

	return result;
}

float get_distance(Vector3* pointA, Vector3* pointB)
{
	float a_x = pointA->x;
	float a_y = pointA->y;
	float a_z = pointA->z;

	float b_x = pointB->x;
	float b_y = pointB->y;
	float b_z = pointB->z;

	double x_ba = (double)(b_x - a_x);
	double y_ba = (double)(b_y - a_y);
	double z_ba = (double)(b_z - a_z);

	double y_2 = y_ba * y_ba;
	double x_2 = x_ba * x_ba;
	double z_2 = z_ba * z_ba;
	double sum = y_2 + x_2 + z_2;

	return (float)std::sqrt(sum);
}

float get_vector_length(Vector3* vector)
{
	double x = (double)vector->x;
	double y = (double)vector->y;
	double z = (double)vector->z;

	return (float)std::sqrt(x * x + y * y + z * z);
}

inline const char * const BoolToString(bool b)
{
	return b ? "true" : "false";
}

Entity GetTargetedEntity(Player player)
{
	Entity entity;
	if (PLAYER::_GET_AIMED_ENTITY(player, &entity))
	{
		if (!ENTITY::DOES_ENTITY_EXIST(entity))
		{
			return NULL;
		}
		else if (ENTITY::IS_ENTITY_A_PED(entity))
		{
			return entity;
		}
		else if (ENTITY::IS_ENTITY_A_VEHICLE(entity))
		{
			return entity;
		}
		else if (ENTITY::IS_ENTITY_AN_OBJECT(entity))
		{
			return entity;
		}
	}
	return NULL;
}

int checkTick = 0;
Entity toProcess = NULL;
bool needsImpacting = false;

void ForcePed(Ped targetEntity, Vector3 resultForce, Vector3 resultRot, Vector3 damageLoc)
{	
	//modify rotation
	float multiplier = 0.02;

	resultRot = multiply(&resultRot, multiplier);

	caption2 = "Force: " + to_string(resultForce.x) + "__" + to_string(resultForce.y) + "__" + to_string(resultForce.z) + "__ROT: " + to_string(resultRot.x) + "__" + to_string(resultRot.y) + "__" + to_string(resultRot.z);

	ENTITY::CLEAR_ENTITY_LAST_DAMAGE_ENTITY(targetEntity);
	PED::SET_PED_CAN_RAGDOLL(targetEntity, true);
	ENTITY::APPLY_FORCE_TO_ENTITY(targetEntity, 1, resultForce.x * 1.5, resultForce.y * 1.5, resultForce.z * 1.5, resultRot.x, resultRot.y, resultRot.z, false, false, true, true, false, true);
}

void ForceVeh(Vehicle targetEntity, Vector3 resultForce, Vector3 resultRot, Vector3 damageLoc, float weaponForce, float radius, float damage)
{
	ENTITY::CLEAR_ENTITY_LAST_DAMAGE_ENTITY(targetEntity);
	//additional bang for helis
	if (VEHICLE::IS_THIS_MODEL_A_HELI(ENTITY::GET_ENTITY_MODEL(targetEntity)))
	{
		VEHICLE::SET_VEHICLE_DAMAGE(targetEntity, damageLoc.x, damageLoc.y, damageLoc.z, 100, 800, 1);
		//apply some extra rotation
		float bang = 1.2;
		float rotAmp = 1.2;
		resultForce= multiply(&resultForce, bang);
		resultRot = multiply(&resultRot, rotAmp);
	}

	//if moving add a flip effect for cars based on velocity
	float speed = ENTITY::GET_ENTITY_SPEED(targetEntity);
	float sForce = weaponForce * 0.5;
	float sRot = 0.75;
	if (abs(speed) > 12.0 && VEHICLE::IS_THIS_MODEL_A_CAR(ENTITY::GET_ENTITY_MODEL(targetEntity)))
	{
		//apply some extra force. faster speeds apply more force
		sForce = sForce - abs(((speed / 20.0) * abs(sForce)));
		sRot = (speed / 18.0) * 0.60;
		resultForce.x = resultForce.x;
		resultForce.y = resultForce.y;
		resultForce.z = resultForce.z + abs(sForce);
		resultRot.x = resultRot.x * 2;
		resultRot.y = resultRot.y;
		resultRot.z = resultRot.z - abs(resultRot.x) - abs(sRot);
		VEHICLE::SET_VEHICLE_DAMAGE(targetEntity, damageLoc.x, damageLoc.y, damageLoc.z, damage, radius, 1);
	}

	caption2 = "Force: " + to_string(resultForce.x) + "__" + to_string(resultForce.y) + "__" + to_string(resultForce.z) + "__ROT: " + to_string(resultRot.x) + "__" + to_string(resultRot.y) + "__" + to_string(resultRot.z);

	ENTITY::APPLY_FORCE_TO_ENTITY(targetEntity, 1, resultForce.x, resultForce.y, resultForce.z, resultRot.x, resultRot.y, resultRot.z, false, false, true, true, false, true);

	//apply destruction damage
	//configurable float values are (damage,radius,spread)
	VEHICLE::SET_VEHICLE_DAMAGE(targetEntity, damageLoc.x, damageLoc.y, damageLoc.z, (damage * 0.5), radius, 1);
	VEHICLE::SET_VEHICLE_DAMAGE(targetEntity, damageLoc.x, damageLoc.y, damageLoc.z, damage, (radius * 0.5), 1);
	VEHICLE::SET_VEHICLE_DAMAGE(targetEntity, damageLoc.x, damageLoc.y, damageLoc.z, damage, (radius * 0.1), 1);
}

//perform impact on entity using a normalized rotation vector
void PerformImpact(Entity targetEntity, Vector3 impactDir, Vector3 impactLoc, Hash weapon, float targetDistance)
{
	if (ENTITY::IS_ENTITY_A_PED(targetEntity) || ENTITY::IS_ENTITY_A_VEHICLE(targetEntity) || ENTITY::IS_ENTITY_AN_OBJECT(targetEntity))
	{
		//push force
		float force = 0.0f;
		//physics damage to vehicles
		float physicsDamage = 0.0f;
		//radius of the effect
		float physicsRadius = 0.0f;

		//read weapon table and lookup values for current weapon
		std::list<WeaponStats>::iterator result = std::find(statList.begin(), statList.end(), weapon);
		if (result != statList.end()) {
			force = result->Force;
			physicsDamage = result->physicsDamage;
			physicsRadius = result->physicsRadius;
		}
		
		caption = "read weapon config force: " + to_string(force) + "__" + to_string(physicsDamage) + "__" + to_string(physicsRadius);

		//falloff will go here
		//net force is less based on distance
		//"400" is extremely far
		//the sniper is at 8 force
		//187.5 distance per force
		//linear
		/*float distanceFactor = (force * 25) / targetDistance;
		if (distanceFactor > 1)
		{
			distanceFactor = 1;
		}
		force = force * distanceFactor;

		caption2 = "applied force: " + to_string(force);*/

		//based on weapon stats, apply force to the directional vector
		Vector3 forceVector = impactDir;
		//peds seem to cap out at a certain force
		if (ENTITY::IS_ENTITY_A_PED(targetEntity))
		{
			if (force > 30)
			{
				force = 30;
			}
		}
		forceVector = multiply(&forceVector, force);

		//identify where on the target we struck
		Vector3 dim1, dim2;
		GAMEPLAY::GET_MODEL_DIMENSIONS(ENTITY::GET_ENTITY_MODEL(targetEntity), &dim1, &dim2);

		Vector3 worldPos = ENTITY::GET_ENTITY_COORDS(targetEntity, true);
		Vector3 target_dir = ENTITY::GET_ENTITY_FORWARD_VECTOR(targetEntity);

		//relative damage position
		Vector3 damageLoc = ENTITY::GET_OFFSET_FROM_ENTITY_GIVEN_WORLD_COORDS(targetEntity, impactLoc.x, impactLoc.y, impactLoc.z);

		Vector3 resultant = add(&target_dir, &forceVector);
		float magnitude = sqrt((resultant.x * resultant.x) + (resultant.y * resultant.y) + (resultant.z, resultant.z));

		float dimx = dim2.x + abs(dim1.x);
		float dimy = dim2.y + abs(dim1.y);
		float dimz = dim2.z + abs(dim2.z);

		float modx = 0.0;
		float mody = 0.0;
		float modz = 0.0;

		Vector3 resultRot;
		resultRot.x = resultant.x / magnitude;
		resultRot.y = resultant.y / magnitude;
		resultRot.z = resultant.z / magnitude;
		if (ENTITY::IS_ENTITY_A_VEHICLE(targetEntity))
		{
			resultRot.x = resultRot.x * 0.25;
		}

		Vector3 resultForce;
		if (ENTITY::IS_ENTITY_A_VEHICLE(targetEntity))
		{
			resultForce.x = forceVector.x - (((impactLoc.x - worldPos.x) / dimx) * forceVector.x);
			resultForce.y = forceVector.y - (((impactLoc.y - worldPos.y) / dimy) * forceVector.y);
			resultForce.z = forceVector.z - (((impactLoc.z - worldPos.z) / dimz) * forceVector.z);
		}
		else
		{
			resultForce.x = forceVector.x;
			resultForce.y = forceVector.y;
			resultForce.z = forceVector.z;
		}

		//some checks to make sure we never apply too much force
		if (abs(resultForce.x) > force)
		{
			resultForce.x = (resultForce.x / abs(resultForce.x)) * force;
		}
		if (abs(resultForce.y) > force)
		{
			resultForce.y = (resultForce.y / abs(resultForce.y)) * force;
		}
		if (abs(resultForce.z) > force)
		{
			resultForce.z = (resultForce.z / abs(resultForce.z)) * force;
		}

		if (damageLoc.x > 0)
		{
			modx = damageLoc.x / dim2.x;
		}
		else
		{
			modx = -damageLoc.x / dim1.x;
		}
		if (damageLoc.y > 0)
		{
			//if abs(dim1.y) + dim2.y
			mody = damageLoc.y / dim2.y;
		}
		else
		{
			mody = -damageLoc.y / dim1.y;
		}
		if (damageLoc.z > 0)
		{
			modz = damageLoc.z / dim2.z;
		}
		else
		{
			modz = -damageLoc.z / dim1.z;
		}

		//some cleanup on the rotation
		if (ENTITY::IS_ENTITY_A_VEHICLE(targetEntity))
		{
			resultRot.x = modz * resultRot.z * 0.5;
			resultRot.y = mody * resultRot.y + modx * resultRot.x;
			resultRot.z = modz * resultRot.z;
		}
		
		//reduce force applied for large objects so it doesnt floop unrealistically
		if (mody > 11 || modz > 8)
		{
			resultForce = multiply(&resultForce, 0.5);
			resultRot = multiply(&resultRot, 0.5);
		}

		if (ENTITY::IS_ENTITY_A_PED(targetEntity))
		{
			ForcePed(targetEntity, resultForce, resultRot, damageLoc);
		}
		else if (ENTITY::IS_ENTITY_A_VEHICLE(targetEntity))
		{			
			ForceVeh(targetEntity, resultForce, resultRot, damageLoc, force, physicsRadius, physicsDamage);
		}
		if (ENTITY::IS_ENTITY_AN_OBJECT(targetEntity))
		{
			ForcePed(targetEntity, resultForce, resultRot, damageLoc);
		}
	}
}

Hash currentWeapon = NULL;
Entity lastAimDump = NULL;
Entity lastAimTarget = NULL;
//last player bullet impact location
//Vector3 impactLoc;
void update_features()
{
	Player player = PLAYER::PLAYER_ID();
	Ped playerPed = PLAYER::GET_PLAYER_PED(player);
	if (!PED::_IS_PED_DEAD(playerPed, true))// && WEAPON::GET_CURRENT_PED_WEAPON(player, sniper, true));
	{
		WEAPON::GET_CURRENT_PED_WEAPON(playerPed, &currentWeapon, true);
		//this should be replaced by pulling all entitities in the current world
		if (GetTargetedEntity(player) != NULL)
		{
			lastAimTarget = GetTargetedEntity(player);
		}
	}
	//for debugging
	//draw_menu_line(caption, 250, 15, 18, 0.0, 5.0, false, true);
	//draw_menu_line(caption2, 250, 15, 38, 0.0, 5.0, false, true);	
	//draw_menu_line(caption3, 250, 15, 58, 0.0, 5.0, false, true);
	//draw_menu_line(caption4, 250, 15, 78, 0.0, 5.0, false, true);
	//draw_menu_line(caption5, 250, 15, 98, 0.0, 5.0, false, true);
	//draw_menu_line(caption6, 250, 15, 118, 0.0, 5.0, false, true);
	//draw_menu_line(caption7, 250, 15, 138, 0.0, 5.0, false, true);
	//some debug to track aim target entity
	if (lastAimTarget != NULL)
	{
		//debug
		if (ENTITY::DOES_ENTITY_EXIST(lastAimTarget))
		{
			float screenx;
			float screeny;
			Vector3 coords = ENTITY::GET_ENTITY_COORDS(lastAimTarget, true);
			//caption = to_string(coords.x) + "_" + to_string(coords.y) + "_" + to_string(coords.z);
		}
	}
	//this mod will proc on presence of a last_weapon_impact
	Vector3 impactFloat;
	if (WEAPON::GET_PED_LAST_WEAPON_IMPACT_COORD(playerPed, &impactFloat) && currentWeapon != NULL)
	{
		caption3 = to_string(impactFloat.x) + "__" + to_string(impactFloat.y) + "__" + to_string(impactFloat.z);
		Vector3 impactLoc;
		impactLoc.x = impactFloat.x;
		impactLoc.y = impactFloat.y;
		impactLoc.z = impactFloat.z;
		Vector3 Rot = CAM::GET_GAMEPLAY_CAM_ROT(2);
		Vector3 direction = RotationToDirection(Rot);
		Vector3 playerLoc = ENTITY::GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(playerPed, 0, 1, 0);
		Vector3 finalLoc = impactLoc;
		//check for a direct hit on ped
		int didHit = 0;
		Vector3 hitCoords;
		Vector3 dummyVector;
		Entity objectHit = NULL;
		int directHitPed = 0;

		//direct hit on veh
		int didHit2 = 0;
		Vector3 hitCoords2;
		Vector3 dummyVector2;
		Entity objectHit2 = NULL;
		int directHitVeh = 0;
		
		//shotgun hashes
		Hash pumpShotgun = GAMEPLAY::GET_HASH_KEY("WEAPON_PUMPSHOTGUN");
		Hash heavyShotgun = GAMEPLAY::GET_HASH_KEY("WEAPON_HEAVYSHOTGUN");		
		Hash sawedShotgun = GAMEPLAY::GET_HASH_KEY("WEAPON_SAWNOFFSHOTGUN");
		Hash assaultShotgun = GAMEPLAY::GET_HASH_KEY("WEAPON_ASSAULTSHOTGUN");

		//perform a slight aoe on the ray if a shotgun
		if (currentWeapon == pumpShotgun || currentWeapon == heavyShotgun || currentWeapon == sawedShotgun || currentWeapon == assaultShotgun)
		{
			directHitPed = WORLDPROBE::_CAST_3D_RAY_POINT_TO_POINT(playerLoc.x, playerLoc.y, playerLoc.z, finalLoc.x, finalLoc.y, finalLoc.z, 0.2, 12, playerPed, 7);
			directHitVeh = WORLDPROBE::_CAST_3D_RAY_POINT_TO_POINT(playerLoc.x, playerLoc.y, playerLoc.z, finalLoc.x, finalLoc.y, finalLoc.z, 0.2, 10, playerPed, 7);
		}
		//otherwise a more precisise radius ray
		else
		{
			directHitPed = WORLDPROBE::_CAST_3D_RAY_POINT_TO_POINT(playerLoc.x, playerLoc.y, playerLoc.z, finalLoc.x, finalLoc.y, finalLoc.z, 0.05, 12, playerPed, 7);
			directHitVeh = WORLDPROBE::_CAST_3D_RAY_POINT_TO_POINT(playerLoc.x, playerLoc.y, playerLoc.z, finalLoc.x, finalLoc.y, finalLoc.z, 0.05, 10, playerPed, 7);
		}
		 
		WORLDPROBE::_GET_RAYCAST_RESULT(directHitPed, &didHit, &hitCoords, &dummyVector, &objectHit);
		WORLDPROBE::_GET_RAYCAST_RESULT(directHitVeh, &didHit2, &hitCoords2, &dummyVector2, &objectHit2);
		caption4 = "ray end: " + to_string(hitCoords2.x) + "__" + to_string(hitCoords2.y) + "__" + to_string(hitCoords2.z);

		//calculate distance to target
		caption2 = to_string(playerLoc.x) + "__" + to_string(playerLoc.y) + "__" + to_string(playerLoc.z);
		float targetDistance = get_distance(&playerLoc, &impactLoc);

		caption4 = to_string(targetDistance);
		try
		{
			if (objectHit != NULL && (didHit == 1) && ENTITY::DOES_ENTITY_EXIST(objectHit) && ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(objectHit, playerPed, true))
			{
				PerformImpact(objectHit, direction, hitCoords, currentWeapon, targetDistance);
			}
			if (objectHit2 != NULL && (didHit2 == 1) && ENTITY::DOES_ENTITY_EXIST(objectHit2) && ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(objectHit2, playerPed, true))
			{
				PerformImpact(objectHit2, direction, hitCoords2, currentWeapon, targetDistance);
			}
		}
		catch (...)
		{
			//this is just in case we get an invalid entity and throw exception while perform operation on it
		}
	}
}

void main()
{
	statList = LoadConfigFile();
	while (true)
	{
		update_features();
		WAIT(0);		
	}
}

void ScriptMain()
{
	srand(GetTickCount());
	main();
}